// @flow

const MongoConnector = require('./connector');
const Random = require('meteor-random');

import type { Collection } from 'mongodb';

class BaseModel {

  connector: MongoConnector;
  random: typeof Random;

  _collectionName: string;
  _collection: Collection;

  get collection(): Collection {
    if (!this._collection) {
      this._collection = this.connector.collection(this._collectionName);
    }
    return this._collection;
  }

  constructor(connector: MongoConnector, collectionName: string) {
    this.connector = connector;
    this._collectionName = collectionName;
  }
}

module.exports = BaseModel;